/**
 * Moi (Luc Sorel, http://www.lucsorel.com/index.php?page=contact) reconnaît être l'auteur de ce code source. 
 * J'ai placé ce code source dans le domaine publique. Vous pouvez utiliser, modifier et distribuer le code 
 * source et les programmes exécutables basés sur ce code source. Veuillez toutefois prendre en considération 
 * les points suivants :
 * 
 * --- Décharge légale de garantie ---
 * Ce code source vous est présenté "en tant que tel" et sans garantie de performance ou d'intérêt commercial. 
 * L'auteur et / ou le distributeur ont pu faire des déclarations ) propos de ce code source. Ces déclarations 
 * n'ont pas valeur de garanties et ne doivent pas servir de fondements quant à l'utilisation tierce de ce code 
 * source.
 * 
 * Ce code source est mis à disposition sans aucune garantie implicite ou explicite. Étant donné la diversité 
 * des conditions contextuelles et matérielles sous lesquelles ce code source peut être utilisé, aucune garantie 
 * d'adéquation pour un usage spécifique n'est proposé. il est conseillé que l'utilisateur teste le code source 
 * consciencieusement avant de s'appuyer dessus. L'utilisateur prend l'entière responsabilité de l'utilisation 
 * de ce code source.
 */

package com.lucsorel.hesperis.client.event;

import com.google.gwt.event.shared.GwtEvent;

public class DemandeConnexionEvent extends GwtEvent<DemandeConnexionHandler>
{
	private static Type<DemandeConnexionHandler> TYPE;
	private String is_login;
	private String is_motDePasse;
	/**
	 * Constructeur de DemandeConnexionEvent
	 */
	public DemandeConnexionEvent( String ps_login, String ps_motDePasse )
	{
		is_login = ps_login;
		is_motDePasse = ps_motDePasse;
	}
	
	/**
	 * @return the is_login
	 */
	public String getLogin()
	{
		return is_login;
	}

	/**
	 * @return the is_motDePasse
	 */
	public String getMotDePasse()
	{
		return is_motDePasse;
	}

	/*
	 * Méthodes requises pour l'association avec le gestionnaire d'événements
	 */
	public static Type<DemandeConnexionHandler> getType()
	{
		return (TYPE != null) ? TYPE : (TYPE = new Type<DemandeConnexionHandler>());
	}
	@Override
	public final Type<DemandeConnexionHandler> getAssociatedType()
	{
		return getType();
	}
	@Override
	protected void dispatch( DemandeConnexionHandler pH_handler )
	{
		pH_handler.onDemandeConnexion( this );
	}
}