/**
 * Moi (Luc Sorel, http://www.lucsorel.com/index.php?page=contact) reconnaît être l'auteur de ce code source. 
 * J'ai placé ce code source dans le domaine publique. Vous pouvez utiliser, modifier et distribuer le code 
 * source et les programmes exécutables basés sur ce code source. Veuillez toutefois prendre en considération 
 * les points suivants :
 * 
 * --- Décharge légale de garantie ---
 * Ce code source vous est présenté "en tant que tel" et sans garantie de performance ou d'intérêt commercial. 
 * L'auteur et / ou le distributeur ont pu faire des déclarations ) propos de ce code source. Ces déclarations 
 * n'ont pas valeur de garanties et ne doivent pas servir de fondements quant à l'utilisation tierce de ce code 
 * source.
 * 
 * Ce code source est mis à disposition sans aucune garantie implicite ou explicite. Étant donné la diversité 
 * des conditions contextuelles et matérielles sous lesquelles ce code source peut être utilisé, aucune garantie 
 * d'adéquation pour un usage spécifique n'est proposé. il est conseillé que l'utilisateur teste le code source 
 * consciencieusement avant de s'appuyer dessus. L'utilisateur prend l'entière responsabilité de l'utilisation 
 * de ce code source.
 */

package com.lucsorel.hesperis.client.tools;

import com.google.gwt.json.client.JSONObject;
import com.google.gwt.json.client.JSONParser;
import com.google.gwt.json.client.JSONValue;

public class JSONTools
{
	static public JSONObject ChaineEstJSONObject( String ps_chaineJSON, String ls_nomObjet )
	{
		JSONObject lJSO_objet = null;

		// évaluation JSON de la chaîne
		JSONValue lJV_json = JSONParser.parse( ps_chaineJSON );

		/* vérifications successives :
		 * - la chaîne est une chaîne JSON représentant un objet
		 * - on y trouve l'entrée du nom de l'objet recherchée
		 * - cette entrée correspond bien à un objet JSON
		 */
		if( (lJV_json.isObject() != null)
				&& (lJV_json.isObject().containsKey(ls_nomObjet))
				&& (lJV_json.isObject().get(ls_nomObjet).isObject() != null) )
		{
			lJSO_objet = lJV_json.isObject().get( ls_nomObjet ).isObject();
		}
		return lJSO_objet;
	}

	static public Boolean PossedeProprieteNumerique( JSONObject pJSO_objet, String ps_nomPropriete )
	{
		boolean lb_possedePropriete = false;
		if( (pJSO_objet != null) && (ps_nomPropriete.length() > 0) )
		{
			lb_possedePropriete = pJSO_objet.containsKey(ps_nomPropriete) 
					&& ( pJSO_objet.get(ps_nomPropriete).isNumber() != null );
		}
		return lb_possedePropriete;
	}
	static public Boolean PossedeProprieteTextuelle( JSONObject pJSO_objet, String ps_nomPropriete )
	{
		boolean lb_possedePropriete = false;
		if( (pJSO_objet != null) && (ps_nomPropriete.length() > 0) )
		{
			lb_possedePropriete = pJSO_objet.containsKey(ps_nomPropriete) 
			&& ( pJSO_objet.get(ps_nomPropriete).isString() != null );
		}
		return lb_possedePropriete;
	}

	static public int ValeurProprieteEntiere( JSONObject pJSO_objet, String ps_nomPropriete )
	{
		int li_valeur = 0;
		if( (pJSO_objet != null) && (ps_nomPropriete.length() > 0)
				&& (PossedeProprieteNumerique(pJSO_objet, ps_nomPropriete)) )
		{
			li_valeur = (int) pJSO_objet.get( ps_nomPropriete ).isNumber().doubleValue();
		}
		return li_valeur;
	}
	static public double ValeurProprieteDecimale( JSONObject pJSO_objet, String ps_nomPropriete )
	{
		double lf_valeur = 0;
		if( (pJSO_objet != null) && (ps_nomPropriete.length() > 0)
				&& (PossedeProprieteNumerique(pJSO_objet, ps_nomPropriete)) )
		{
			lf_valeur = pJSO_objet.get( ps_nomPropriete ).isNumber().doubleValue();
		}
		return lf_valeur;
	}
	static public String ValeurProprieteTextuelle( JSONObject pJSO_objet, String ps_nomPropriete )
	{
		String ls_valeur = "";
		if( (pJSO_objet != null) && (ps_nomPropriete.length() > 0)
				&& (PossedeProprieteTextuelle(pJSO_objet, ps_nomPropriete)) )
		{
			ls_valeur = pJSO_objet.get( ps_nomPropriete ).isString().stringValue();
		}
		return ls_valeur;
	}
}